Prime Path
Time Limit: 1000MS | Memory Limit: 65536K | |
Total Submissions: 28338 | Accepted: 15457 |
Description
The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.
Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Sample Input
3
1033 8179
1373 8017
1033 1033
Sample Output
6
7
0
Source
题意:
给你两个四位数:a 和 b (两者均没有前导0)
从a开始,每次只改变a的一位,(并且要使改变过后的数为素数),问需要多少步能将a变成b。如果不可能的话,输出impossible。
例如
1033
1733
3733
3739
3779
8779
8179
#include<cstdio>
#include<cstring>
#include<iostream>
#include<algorithm>
#include<cmath>
#include<map>
#include<queue>
using namespace std;
#define LL long long
#define M(a,b) memset(a,b,sizeof(a))
const int MAXN = 1e5+5;
const int INF = 0x3f3f3f3f;
int tag[MAXN];
int prime[MAXN];
int vis[MAXN];
int n1,n2,ans;
queue<int>q;
void Prime()///素数线性筛
{
memset(tag,0,sizeof(tag));
int cnt=0;
tag[0]=tag[1]=1;
for(int i = 1; i<MAXN; i++)
{
if(!tag[i])
{
prime[cnt++]=i;
}
for(int j=0; j<cnt && prime[j]*i<MAXN; j++)
{
tag[i*prime[j]] = 1;
if(i % prime[j]==0)
break;
}
}
}
int bfs(int s)
{
q.push(s);
vis[s] = 1;
while(!q.empty())
{
int temp = q.front();
q.pop();
//printf("temp==%d\n",temp);
if(temp==n2)
{
return vis[n2]-1;
}
int a1,a2,a3,a4;///拆成四位
a1 = temp%10;
a2 = (temp/10)%10;
a3 = (temp/100)%10;
a4 = (temp/1000);
for(int i=1; i<=9; i++)///依次枚举,最高位不能为0
{
if(i!=a4)
{
int temp2 = 0;
temp2 = i*1000+a3*100+a2*10+a1;
if(vis[temp2]==0&&tag[temp2]==0)///未被访问,而且要是素数
{
q.push(temp2);
vis[temp2] = vis[temp]+1;
}
}
}
for(int i=0; i<=9; i++)
{
if(i!=a3)
{
int temp2 = 0;
temp2 = a4*1000+i*100+a2*10+a1;
if(vis[temp2]==0&&tag[temp2]==0)
{
q.push(temp2);
vis[temp2] = vis[temp]+1;
}
}
}
for(int i=0; i<=9; i++)
{
if(i!=a2)
{
int temp2 = 0;
temp2 = a4*1000+a3*100+i*10+a1;
if(vis[temp2]==0&&tag[temp2]==0)
{
q.push(temp2);
vis[temp2] = vis[temp]+1;
}
}
}
for(int i=0; i<=9; i++)
{
if(i!=a1)
{
int temp2 = 0;
temp2 = a4*1000+a3*100+a2*10+i;
if(vis[temp2]==0&&tag[temp2]==0)
{
q.push(temp2);
vis[temp2] = vis[temp]+1;
}
}
}
}
return -1;
}
void init()
{
while(!q.empty()) q.pop();
M(vis,0);
}
int main()
{
Prime();
int T;
cin>>T;
while(T--)
{
init();
scanf("%d %d",&n1,&n2);
ans = bfs(n1);
if(tag[n2]!=0)
{
printf("Impossible\n");
continue;
}
if(ans==-1)
{
printf("Impossible\n");
}
else
{
printf("%d\n",ans);
}
}
return 0;
}